//Julian Esteban Palacio Hernández
//Andres Mauricio Gomez Arevalo

#include "mbed.h"
#include "DebouncedIn.h" // esta librería permite trabajar entradas salidas mas facilmente

DigitalOut led1(LED1);  //led rojo
DigitalOut led2(LED2);  //Led Verde
DigitalOut led3(LED3);  //Led Azul

//Rojo-Verde= Amarillo
//Rojo-Azul= Violeta
//Verde-Azul= Cyan
//Rojo-Verde-Azul=Blanco



DebouncedIn Pulso(PTA17); //Defino la entrada del pulsador. Nota: se escogió este puerto porque era el más cercano a GND, para así conectar directamente el pulsador al micro

//definiendo variables

float Cont=0.02; //Contador  (inicia con un tiempo de on/off de 20ms)
float Inc=0.01; //Incrementos de (10 ms)


int main() {
    
    while(true){
        
        if(Pulso.falling()) // Detección de flanco
                {
                    Cont=Cont+Inc;  //Aumenta el tiempo de espera, por lo tanto el tiempo de oscilación del led
                    
                    if(Cont>0.5)    // limite para el tiempo de oscilación
                    {
                        Cont=0.02;  //vuelve a la condición inicial
                        }
                }
                
    //Prendido y apagado
        led1=!led1;     //Alterna entre prendido y apagado del led1 (Rojo)
        led2=!led2;     //Alterna entre prendido y apagado del led2 (Verde)
        led3=!led3;     //Alterna entre prendido y apagado del led3 (Azul)
        wait(Cont);     //Espera el tiempo del contador    

    }
}